
#include <digitalWriteFast.h> 

#define BAUD    (115600)
#define encoder0PinA  2
#define encoder0PinB  4

const int greenLed = 11;
const int redLed = 13;
const int yellowLed = 12;
const int buttonGreen = 8;
const int buttonRed = 10;



char buffer[128];
int sofar;



void setup() {
  pinMode(encoder0PinA, INPUT); 
  digitalWrite(encoder0PinA, HIGH);
  pinMode(encoder0PinB, INPUT); 
  digitalWrite(encoder0PinB, HIGH);
  
  
  Serial.begin(BAUD);
  
  
  

  pinMode(greenLed, OUTPUT);
  pinMode(redLed,   OUTPUT);
  pinMode(yellowLed, OUTPUT);
  
  digitalWrite(redLed,HIGH);
  digitalWrite(yellowLed,HIGH);
  digitalWrite(greenLed,HIGH);
  delay (100);
  digitalWrite(greenLed,LOW);
  digitalWrite(yellowLed,LOW);
  digitalWrite(redLed,LOW);


}

void readserial(){
  
   // listen for serial commands
  while(Serial.available() > 0) {
    buffer[sofar++]=Serial.read();
    if(buffer[sofar-1]==';') break;  // in case there are multiple instructions
    
  }
  if(sofar>0 && buffer[sofar-3]=='+') {
    if(sofar>0 && buffer[sofar-2]=='Y') { 
      digitalWrite(yellowLed,HIGH);
    }
  }
  if(sofar>0 && buffer[sofar-3]=='-') {
    if(sofar>0 && buffer[sofar-2]=='Y') { 
      digitalWrite(yellowLed,LOW);
    }
  } 
  if(sofar>0 && buffer[sofar-3]=='+') {
    if(sofar>0 && buffer[sofar-2]=='G') { 
      digitalWrite(greenLed,HIGH);
    }
  }
  if(sofar>0 && buffer[sofar-3]=='-') {
    if(sofar>0 && buffer[sofar-2]=='G') { 
      digitalWrite(greenLed,LOW);
    }
  }
  if(sofar>0 && buffer[sofar-3]=='+') {
    if(sofar>0 && buffer[sofar-2]=='R') { 
      digitalWrite(redLed,HIGH);
    }
  }
  if(sofar>0 && buffer[sofar-3]=='-') {
    if(sofar>0 && buffer[sofar-2]=='R') { 
      digitalWrite(redLed,LOW);
    }
  }
}

void encoder(){
byte na = digitalRead(encoder0PinA), nb = digitalRead(encoder0PinB); // Lit l'état des deux broches
  static byte old = LOW; // Ancienne valeur de encoder0PinA (valeur static = valeur persistante)
  char val = 0; // Valeur de retour (0 = pas de mouvement, 1 ou -1 = rotation de l'encodeur)
 
  if(old != na) { // Si l'encodeur a été tourné
    if(na) { // Test du sens de rotation
      if(!nb) Serial.println("Fe-1"); 
      else Serial.println("Fe+1"); // Test du sens de rotation
    }
    else {
      if(!nb) Serial.println("Fe+1"); 
      else Serial.println("Fe-1"); // Test du sens de rotation
    }
  
  }
  old = na; // Garde en mémoire la nouvelle valeur de encoder0PinA
  
}

void button (){
  
 //Bouton vert 
  if (digitalRead(buttonGreen) == HIGH){
    Serial.println ("0DCY");
     
  }

  //Bouton rouge
  if (digitalRead(buttonRed) == HIGH){
    Serial.println ("0PAU");
  }
}
  
  

void loop() {
    
  readserial();
  
  encoder();
  
  button();

  
}
 
