#!/usr/bin/python
import serial
import hal
import sys
import time

PORT = "/dev/ttyACM0"
ser = serial.Serial(PORT, 115200, timeout=15)
time.sleep(2)

c = hal.component("arduino")
#states pin
c.newpin("programis-running",hal.HAL_BIT,hal.HAL_IN)
c.newpin("programis-posed",hal.HAL_BIT,hal.HAL_IN)

#action pins
c.newpin("green-btn",hal.HAL_BIT,hal.HAL_IN)
c.newpin("red-btn",hal.HAL_BIT,hal.HAL_IN)
c.newpin("feed-override-decrease",hal.HAL_BIT,hal.HAL_IN)
c.newpin("feed-override-increase",hal.HAL_BIT,hal.HAL_IN)

c.ready()

programIsrunning	= c['programis-running']
programIsposed		= c['programis-posed']


try:
	while 1:
		time.sleep(.01)
		while ser.inWaiting():
			key = ser.readline(4)
				
			
			if key == "Fe+1":
				c['feed-override-increase'] = 1
				time.sleep(.01)
			else:
				c['feed-override-increase'] = 0
				time.sleep(.01)
				
			if key == "Fe-1":
				c['feed-override-decrease'] = 1
				time.sleep(.01)
			else:
				c['feed-override-decrease'] = 0
				time.sleep(.01)
	
	
			if(key == "0DCY"):
				c['green-btn'] = 1
			else:
				c['green-btn'] = 0
									
			if key == "0PAU":
				c['red-btn'] = 1
			else:
				c['red-btn'] = 0

		
########################################################################
		if programIsrunning != c['programis-running']:
			if(c['programis-running'] == 1):
				ser.write("+G;")
			else:
				ser.write("-G;")
			programIsrunning= c['programis-running']


		if programIsposed  != c['programis-posed']:
			if(c['programis-posed'] == 1):
				ser.write("+P;")
			else:
				ser.write("-P;")
			programIsposed  = c['programis-posed']
			

		
				
		
except KeyboardInterrupt:
	raise SystemExit

